/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.60 Revision 1.69
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.60 2008/05/15 14:03:15 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.69 2009/03/24 21:10:13 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8 76COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 ) 77
78 >=app-admin/eselect-vdr-0.0.2 78DEPEND="${COMMON_DEPEND}
79 media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
80RDEPEND="${COMMON_DEPEND}
81 >=app-admin/eselect-vdr-0.0.2"
80 82
83# this is a hack for ebuilds like vdr-xineliboutput that want to
84# conditionally install a vdr-plugin
85if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
86 # make DEPEND conditional
87 IUSE="${IUSE} vdr"
88 DEPEND="vdr? ( ${DEPEND} )"
89 RDEPEND="vdr? ( ${RDEPEND} )"
90fi
81 91
82# New method of storing plugindb 92# New method of storing plugindb
83# Called from src_install 93# Called from src_install
84# file maintained by normal portage-methods 94# file maintained by normal portage-methods
85create_plugindb_file() { 95create_plugindb_file() {
183 # To satisfy 1-3 we do this: 193 # To satisfy 1-3 we do this:
184 # Set VDRDIR=/usr/include/vdr 194 # Set VDRDIR=/usr/include/vdr
185 # Set VDRINCDIR=/usr/include 195 # Set VDRINCDIR=/usr/include
186 # Change $(VDRDIR)/include to $(VDRINCDIR) 196 # Change $(VDRDIR)/include to $(VDRINCDIR)
187 197
188 ebegin " Setting Pathes" 198 ebegin " Setting paths"
189 sed -i Makefile \ 199 sed -i Makefile \
190 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 200 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
191 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \ 201 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
192 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \ 202 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
193 \ 203 \
295vdr_i18n() { 305vdr_i18n() {
296 if vdr_has_gettext; then 306 if vdr_has_gettext; then
297 einfo "VDR has gettext support" 307 einfo "VDR has gettext support"
298 if plugin_has_gettext; then 308 if plugin_has_gettext; then
299 einfo "Plugin has gettext support, fine" 309 einfo "Plugin has gettext support, fine"
310 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
311 ewarn "Please remove left over NO_GETTEXT_HACK."
312 fi
300 else 313 else
301 vdr_i18n_convert_to_gettext 314 vdr_i18n_convert_to_gettext
302 if [[ $? != 0 ]]; then 315 if [[ $? != 0 ]]; then
303 eerror "" 316 eerror ""
304 eerror "Plugin will have only english OSD texts" 317 eerror "Plugin will have only english OSD texts"
335 348
336 dosym "${VDRPLUGIN}-${PV}" "${destdir}" 349 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
337} 350}
338 351
339vdr-plugin_print_enable_command() { 352vdr-plugin_print_enable_command() {
353 local p_name c=0 l=""
354 for p_name in ${vdr_plugin_list}; do
355 c=$(( c+1 ))
356 l="$l ${p_name#vdr-}"
357 done
358
340 elog 359 elog
360 case $c in
361 1) elog "Installed plugin${l}" ;;
362 *) elog "Installed $c plugins:${l}" ;;
363 esac
341 elog "To activate this vdr-plugin execute the following command:" 364 elog "To activate a plugin execute this command:"
342 elog "\teselect vdr-plugin enable ${PN#vdr-}" 365 elog "\teselect vdr-plugin enable <plugin_name> ..."
343 elog 366 elog
344} 367}
345 368
369has_vdr() {
370 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
371}
346 372
347## exported functions 373## exported functions
348 374
349vdr-plugin_pkg_setup() { 375vdr-plugin_pkg_setup() {
350 # -fPIC is needed for shared objects on some platforms (amd64 and others) 376 # -fPIC is needed for shared objects on some platforms (amd64 and others)
363 DVB_INCLUDE_DIR="/usr/include" 389 DVB_INCLUDE_DIR="/usr/include"
364 390
365 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 391 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
366 LOCDIR="/usr/share/vdr/locale" 392 LOCDIR="/usr/share/vdr/locale"
367 393
368 TMP_LIBDIR="${WORKDIR}/tmp-libdir" 394 if ! has_vdr; then
395 # set to invalid values to detect abuses
396 VDRVERSION="eclass_no_vdr_installed"
397 APIVERSION="eclass_no_vdr_installed"
369 398
399 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
400 einfo "VDR not found!"
401 else
402 # if vdr is required
403 die "VDR not found!"
404 fi
405 return
406 fi
407
370 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 408 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
371 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 409 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
372 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 410 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
373 411
374 einfo "Compiling against" 412 einfo "Compiling against"
375 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]" 413 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
414}
415
416vdr-plugin_src_util() {
417
418 while [ "$1" ]; do
419
420 case "$1" in
421 all)
422 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
423 ;;
424 prepare|all_but_unpack)
425 vdr-plugin_src_util add_local_patch patchmakefile i18n
426 ;;
427 unpack)
428 base_src_unpack
429 ;;
430 add_local_patch)
431 cd "${S}" || die "Could not change to plugin-source-directory!"
432 vdr_add_local_patch
433 ;;
434 patchmakefile)
435 cd "${S}" || die "Could not change to plugin-source-directory!"
436 vdr_patchmakefile
437 ;;
438 i18n)
439 cd "${S}" || die "Could not change to plugin-source-directory!"
440 vdr_i18n
441 ;;
442 esac
443
444 shift
445 done
376} 446}
377 447
378vdr-plugin_src_unpack() { 448vdr-plugin_src_unpack() {
379 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 449 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
380 eerror "Wrong use of vdr-plugin.eclass." 450 eerror "Wrong use of vdr-plugin.eclass."
381 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 451 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
382 echo 452 echo
383 eerror "Please report this at bugs.gentoo.org." 453 eerror "Please report this at bugs.gentoo.org."
384 die "vdr-plugin_pkg_setup not called!" 454 die "vdr-plugin_pkg_setup not called!"
385 fi 455 fi
386 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 456 if [ -z "$1" ]; then
457 case "${EAPI:-0}" in
458 2)
459 vdr-plugin_src_util unpack
460 ;;
461 *)
462 vdr-plugin_src_util all
463 ;;
464 esac
465
466 else
467 vdr-plugin_src_util $@
468 fi
469}
470
471vdr-plugin_src_prepare() {
472 base_src_prepare
473 vdr-plugin_src_util prepare
474}
475
476vdr-plugin_src_compile() {
477 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
387 478
388 while [ "$1" ]; do 479 while [ "$1" ]; do
389 480
390 case "$1" in 481 case "$1" in
391 all_but_unpack) 482 copy_source)
392 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
393 ;;
394 unpack)
395 base_src_unpack
396 ;;
397 add_local_patch)
398 cd "${S}" || die "Could not change to plugin-source-directory!"
399 vdr_add_local_patch
400 ;;
401 patchmakefile)
402 cd "${S}" || die "Could not change to plugin-source-directory!"
403 vdr_patchmakefile
404 ;;
405 i18n)
406 cd "${S}" || die "Could not change to plugin-source-directory!"
407 vdr_i18n
408 ;;
409 esac
410
411 shift
412 done
413}
414
415vdr-plugin_src_compile() {
416 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
417
418 while [ "$1" ]; do
419
420 case "$1" in
421 prepare)
422 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 483 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
423 ;; 484 ;;
424 compile) 485 compile)
425 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 486 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
426 eerror "Wrong use of vdr-plugin.eclass." 487 eerror "Wrong use of vdr-plugin.eclass."
430 eerror "Please report this at bugs.gentoo.org." 491 eerror "Please report this at bugs.gentoo.org."
431 die "vdr-plugin_src_unpack not called!" 492 die "vdr-plugin_src_unpack not called!"
432 fi 493 fi
433 cd "${S}" 494 cd "${S}"
434 495
435 mkdir -p "${TMP_LIBDIR}" 496 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
497
436 emake ${BUILD_PARAMS} \ 498 emake ${BUILD_PARAMS} \
437 ${VDRPLUGIN_MAKE_TARGET:-all} \ 499 ${BUILD_TARGETS} \
438 LOCALEDIR="${TMP_LOCALE_DIR}" \ 500 LOCALEDIR="${TMP_LOCALE_DIR}" \
439 LIBDIR="${TMP_LIBDIR}" \ 501 LIBDIR="${S}" \
440 TMPDIR="${T}" \ 502 TMPDIR="${T}" \
441 || die "emake failed" 503 || die "emake failed"
442 ;; 504 ;;
443 esac 505 esac
444 506
467 doins "${mname}.patched" 529 doins "${mname}.patched"
468 530
469 fi 531 fi
470 532
471 533
472 local p_list="" p_name
473 534
474 cd "${TMP_LIBDIR}" 535 cd "${S}"
536 insinto "${VDR_PLUGIN_DIR}"
537 doins libvdr-*.so.*
538
539 # create list of all created plugin libs
540 vdr_plugin_list=""
541 local p_name
475 for p in libvdr-*.so.*; do 542 for p in libvdr-*.so.*; do
476 p_name="${p%.so*}" 543 p_name="${p%.so*}"
477 p_name="${p_name#lib}" 544 p_name="${p_name#lib}"
478 p_list="${p_list} ${p_name}" 545 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
479
480 insinto "${VDR_PLUGIN_DIR}"
481 doins "$p"
482 done 546 done
483 547
484 create_header_checksum_file ${p_list} 548 create_header_checksum_file ${vdr_plugin_list}
485 create_plugindb_file ${p_list} 549 create_plugindb_file ${vdr_plugin_list}
486 550
487 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then 551 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
488 einfo "Installing locales" 552 einfo "Installing locales"
489 cd "${TMP_LOCALE_DIR}" 553 cd "${TMP_LOCALE_DIR}"
490 insinto "${LOCDIR}" 554 insinto "${LOCDIR}"
531vdr-plugin_pkg_config() { 595vdr-plugin_pkg_config() {
532 ewarn "emerge --config ${PN} is no longer supported" 596 ewarn "emerge --config ${PN} is no longer supported"
533 vdr-plugin_print_enable_command 597 vdr-plugin_print_enable_command
534} 598}
535 599
600case "${EAPI:-0}" in
601 2)
602 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
603 ;;
604 *)
536EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 605 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
606 ;;
607esac

Legend:
Removed from v.1.60  
changed lines
  Added in v.1.69

  ViewVC Help
Powered by ViewVC 1.1.20